#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

bool compareStrings(string l, string r) {
	if (l.length() == r.length()) {
		return l < r;
	}
	return l.length() < r.length();
}

void loadData(ifstream& in, vector<string>& words) {
	string word;
	while (getline(in, word)) {
		words.push_back(word);
	}

	in.close();
}

void sortData(vector<string>& words) {
	sort(words.begin(), words.end(), compareStrings);
}

void printData(vector<string>& words) {
	for (auto& i : words) {
		cout << i << endl;
	}
}

int main() {
	ifstream in("nounlist.csv");
	if (!in) {
		cout << "404" << endl;
		return 1;
	}

	vector<string> words;

	// Loading all of the words
	loadData(in, words);
	// Sorting them by their length and alphabetically
	sortData(words);
	// Printing all of the words
	printData(words);

	return 0;
}